<?php
ini_set('pcre.jit', '0');
class Worker {
	private $filepath = false;
	private $filename = false;
	private $id = false;
	private $change_id = false;
	private $workdir = false;
	private $home_dir = false;
	private $cache_dir = false;
	private $prefs_face_max_width_height = false;
	private $prefs_thumb_max_width_height = false;
    private $prefs_thumb_max_filesize = false;
    private $prefs_checksum = false;
    private $prefs_exif = false;
    private $prefs_created = false;
    private $prefs_filename = false;
    private $prefs_width = false;
    private $prefs_height = false;
    private $prefs_filesize = false;
    private $prefs_mode = false;
    private $prefs_perceptive_tolerance = false;
    public $checksum = "";
    private $pixels = null;
    private $filesize = null;
    private $width = null;
    private $height = null;
    private $dbfilename = false;
    private $fingerprint = false;
    private $exifdate = false;
    private $phpversion = "system";
    
	public function __construct($job, $workdir, $prefs_face_max_width_height, $prefs_thumb_max_width_height, $prefs_mode, $prefs_checksum, $prefs_exif, $prefs_created, $prefs_filename, $prefs_width, $prefs_height, $prefs_filesize, $prefs_perceptive_tolerance, $phpversion, $prefs_thumb_max_filesize) {
        echo "DEBUG WORKER INPUT:\n${job}\n";
        $tmp = explode("%BREAKPOINT%", trim($job));
		
        echo "DEBUG WORKER INPUT:\n${job}\n";
        var_dump($tmp);
        echo "\n";
        
        $this->id = $tmp[0];
		$this->filepath = $tmp[1];
		$this->change_id = $tmp[2];
        $this->filesize = $tmp[3];
        $this->width = (int)$tmp[4];
        $this->height = (int)$tmp[5];
        
        // start 7.5.0
        if (isset($tmp[6]) AND trim($tmp[6]) != "") {
            $this->fingerprint = $tmp[6];
        }
        
        if (isset($tmp[7]) AND trim($tmp[7]) != "") {
            $this->exifdate = $tmp[7];
        }
        
        if (isset($tmp[8]) AND trim($tmp[8]) != "") {
            $this->dbfilename = $tmp[8];
        }
        // end 7.5.0
        
        $this->prefs_face_max_width_height = $prefs_face_max_width_height;
		$this->prefs_thumb_max_width_height = $prefs_thumb_max_width_height;
        $this->prefs_thumb_max_filesize = $prefs_thumb_max_filesize*1024;
        $this->prefs_checksum = $this->do_boolean($prefs_checksum);
        $this->prefs_exif = $this->do_boolean($prefs_exif);
        $this->prefs_created = $this->do_boolean($prefs_created);
        $this->prefs_filename = $this->do_boolean($prefs_filename);
        $this->prefs_width = $this->do_boolean($prefs_width);
        $this->prefs_height = $this->do_boolean($prefs_height);
        $this->prefs_filesize = $this->do_boolean($prefs_filesize);
        $this->prefs_mode = $prefs_mode;
        $this->prefs_perceptive_tolerance = $prefs_perceptive_tolerance;
        $this->phpversion = $phpversion;
        
        echo "WORKER mode = ".$prefs_mode."\n";
        
		$this->workdir = trim($workdir);
		$this->home_dir = trim(shell_exec("echo ~"));
        $this->cache_dir = $this->home_dir."/Library/Caches/com.brattoo.duplicate-annihilator-photos/";
		$this->process();
	}

    private function do_boolean($string) {
        if ($string == "true") {
            return true;
        } elseif ($string == "false") {
            return false;
        } else {
            return $string;
        }
    }

	private function get_cache($name) {
        //return false; //TODO aktivera cache

		$hash = hash("sha512", $this->filepath.$name.$this->change_id);
		$tmp = substr($hash, 0, 3);
		if (is_readable($this->cache_dir.$tmp."/".$hash)) {
			echo "cache ($name)\n";
            return file_get_contents($this->cache_dir.$tmp."/".$hash);
		} else {
			return false;
		}
	}

	private function set_cache($name, $value) {
        if ($value) {
	    	$hash = hash("sha512", $this->filepath.$name.$this->change_id);
		    $tmp = substr($hash, 0, 3);
		    @mkdir ($this->cache_dir.$tmp);
		    file_put_contents($this->cache_dir.$tmp."/".$hash, $value);
        }
	}

	private function process() {
		if (preg_match("/iLifeAssetManagement/", $this->filepath)) {
			echo "LOG: ignored photostream (".$this->filepath.")\n";
			$this->write("PROCESSED.txt", ".");
			return;
		} else {
			if (is_readable($this->filepath)){
				
				
                if ($this->dbfilename) {
                    $this->filename = $this->dbfilename; // 7.5.0
                    $tmp = pathinfo($this->filename);
                    $extension = strtoupper($tmp["extension"]);
                }else{
                    $tmp = pathinfo($this->filepath);
                    $this->filename = $tmp["basename"];
                    $extension = strtoupper($tmp["extension"]);
                }
                
                
				
               /*
				if (! $this->filesize = $this->get_cache("filesize")) {
			 		if($this->filesize = filesize($this->filepath)) {
						$this->set_cache("filesize", $this->filesize);
					}
				} 
				*/
                
				if ($extension == "JPG" || $extension == "JPEG") {
					if (preg_match("/Error\:\ Error\ querying\ file/i", @shell_exec("sips -g all \"".preg_replace("/\\\'/", "'", escapeshellcmd($this->filepath))."\""))){
						echo "LOG: corrupt (".$this->filepath.")\n";
						$this->write("CORRUPT.txt", $this->id);
						$this->write("FILESIZE.txt", $this->filesize);
						$this->write("PROCESSED.txt", ".");
						return;
					}
				}
				/*
				if (! $width = $this->get_cache("width")) {
			 		$tmp = @shell_exec("sips -g pixelWidth \"".preg_replace("/\\\'/", "'", escapeshellcmd($this->filepath))."\"");
	                if(preg_match("/pixelWidth: ([0-9]{1,})/", $tmp, $matches)){
						$width = $matches[1];
					} else {
						$width = "100000";
					}
					$this->set_cache("width", $width);
				}
				*/
                $width = $this->width;
                
				/*
                if (! $height = $this->get_cache("height")) {
			 		$tmp = @shell_exec("sips -g pixelHeight \"".preg_replace("/\\\'/", "'", escapeshellcmd($this->filepath))."\"");
					if(preg_match("/pixelHeight: ([0-9]{1,})/", $tmp, $matches)){
						$height = $matches[1];
					} else {
						$height = "100000";
					}
					$this->set_cache("height", $height);
				}
                */
                
                $height = $this->height;
				
				// TODO vad gör vi med filer som saknar bredd och höjd t.ex filmer?
				
				echo $this->filepath." W:".$width." H:".$height." P:".$this->prefs_face_max_width_height."\n";
				
                if (($width > 0) AND ($height > 0)) {
                    if (($width == $height) && ($width <= $this->prefs_face_max_width_height) && ($width <= $this->prefs_face_max_width_height)) {
                        echo "LOG: face (".$this->filepath.")\n";
                        $this->write("FACES.txt", $this->id);
                        $this->write("FILESIZE.txt", $this->filesize);
                        $this->write("PROCESSED.txt", ".");
                        
                        if ($this->prefs_mode != "perceptive") {
                            return;
                        }
                    }
                    
                    if (($width <= $this->prefs_thumb_max_width_height) && ($height <= $this->prefs_thumb_max_width_height) &&($this->filesize <= $this->prefs_thumb_max_filesize)) {
                        echo "LOG: thumb (".$this->filepath.") ${width} <= ".$this->prefs_thumb_max_width_height.") && (${width} <= ".$this->prefs_thumb_max_width_height." && (".$this->filesize." <= ".$this->prefs_thumb_max_filesize."\n";
                        $this->write("THUMBNAILS.txt", $this->id);
                        $this->write("FILESIZE.txt", $this->filesize);
                        $this->write("PROCESSED.txt", ".");
                        
                        if ($this->prefs_mode != "perceptive") {
                            return;
                        }
                    }
				}
                
				$this->pixels = $width*$height;

                echo "DEBUG mode: ".$this->prefs_mode."\n";
                if ($this->prefs_mode == "perceptive") {
                    echo "DEBUG: Perception mode\n";
                    // perception mode
                    
                    $hash = $this->calculate_hash($this->filepath);
                    
                    $this->write_CRC($hash);
                    
                } else {
                    if ($this->prefs_checksum) {
                        if (! $tmp = $this->get_cache("checksum")) {
                            if ($this->fingerprint) {
                                $tmp = $this->fingerprint.$this->change_id; // 7.5.0
                            }else{
                                $tmp = sha1_file($this->filepath).$this->change_id;
                            }
                            $this->set_cache("checksum", $tmp);
                        }

                        $this->write_CRC($tmp);
                    }

                    if ($this->prefs_exif) {
                        if (! $exif = $this->get_cache("exif")) {
                           if ($this->exifdate) {
                               $exif = $this->exifdate;
                           }else{
                                $tmp = @exif_read_data($this->filepath);

                                if (isset($tmp["DateTimeOriginal"])) {
                                    $exif = $tmp["DateTimeOriginal"];
                                } else {
                                    $exif = false;
                                }
                            }
                            
                            $this->set_cache("exif", $exif);
                        }

                        $this->write_CRC($exif);
                    }

                    if ($this->prefs_created) {
                        if (! $created = $this->get_cache("created")) {
                            $tmp = @exif_read_data($this->filepath);

                            if (isset($tmp["DateTime"])) {
                                $created = $tmp["DateTime"];
                            } else {
                                $created = false;
                            }

                            $this->set_cache("created", $created);
                        }

                        $this->write_CRC($created);
                    }

                    if ($this->prefs_filename) {
                        $tmp = mb_substr($this->filename, 0, $this->prefs_filename);
                        $this->write_CRC($tmp);
                    }

                    if ($this->prefs_width) {
                        $this->write_CRC($width);
                    }

                    if ($this->prefs_height) {
                        $this->write_CRC($height);
                    }

                    if ($this->prefs_filesize) {
                        $this->write_CRC($this->filesize);
                    }

                    if ($this->prefs_mode == "all") {
                        if (strlen($this->checksum) > 1) {
                            $tmp = substr(md5($this->checksum), 0, 3)."_";
                            $this->write($tmp."CRC_IMAGEID.txt", $this->checksum."%BREAKPOINT%".$this->id."%BREAKPOINT%".$this->pixels."%BREAKPOINT%".$this->filesize);
                            $this->write("CRC_NO_IMAGEID.txt", $this->checksum);
                        }
                    }
                }
	            $this->write("PROCESSED.txt", ".");
			} elseif($this->exifdate OR $this->fingerprint) {
                // 7.5.0 (hela den här elseif:en)
                
                $ok = false;
                
                if ($this->prefs_checksum) {
                    if (! $tmp = $this->get_cache("checksum")) {
                        if ($this->fingerprint) {
                            $tmp = $this->fingerprint.$this->change_id; // 7.5.0
                            $this->set_cache("checksum", $tmp);
                        }
                    }

                    $this->write_CRC($tmp);
                    
                    if ($tmp) {
                        $ok = true;
                    }
                }

                if ($this->prefs_exif) {
                    if (! $exif = $this->get_cache("exif")) {
                       if ($this->exifdate) {
                           $exif = $this->exifdate;
                       
                           $this->set_cache("exif", $exif);
                       }
                    }

                    $this->write_CRC($exif);
                    if ($tmp) {
                        $ok = true;
                    }
                }
                
                if ($ok) {
                    if ($this->prefs_mode == "all") {
                        if (strlen($this->checksum) > 1) {
                            $tmp = substr(md5($this->checksum), 0, 3)."_";
                            $this->write($tmp."CRC_IMAGEID.txt", $this->checksum."%BREAKPOINT%".$this->id."%BREAKPOINT%".$this->pixels."%BREAKPOINT%".$this->filesize);
                            $this->write("CRC_NO_IMAGEID.txt", $this->checksum);
                        }
                    }
                }else{
                    echo "LOG: missing A (".$this->filepath.")\n";
                    $this->write("MISSING.txt", $this->id);
                }
                
                $this->write("PROCESSED.txt", ".");
            } else {
				echo "LOG: missing B (".$this->filepath.")\n";
				$this->write("MISSING.txt", $this->id);
				$this->write("PROCESSED.txt", ".");
				return;
			}
		}
	}

    private function write_CRC($crc) {
        if ($crc) {
            if ($this->prefs_mode == "all") {
                $this->checksum .= $crc;
            } else {
            	$tmp = substr(md5($crc), 0, 3)."_";
                $this->write($tmp."CRC_IMAGEID.txt", $crc . "%BREAKPOINT%" . $this->id . "%BREAKPOINT%" . $this->pixels . "%BREAKPOINT%" . $this->filesize);
                $this->write("CRC_NO_IMAGEID.txt", $crc);
            }
        }
    }

	private function write($name, $string) {
		file_put_contents($this->workdir.$name, $string."\n", FILE_APPEND);
	}
    
    private function calculate_hash($filepath, $hamming_length=8) {
        if (!is_readable($filepath)) {

            echo "CH: missing: ${filepath}\n";
            return false;
        }
        
        $binary_string = "";
        
        $tolerance = (int)$this->prefs_perceptive_tolerance;
        
        
        if ($this->phpversion == "brattoo") {
            echo "CH: php: brattoo\n";
            echo escapeshellarg(__DIR__."/imagehash")." ".escapeshellarg($filepath)."\n";
            $data = false;
            $retry = 0;
            while($retry<10 AND $data == false) {
                $data = shell_exec(escapeshellarg(__DIR__."/imagehash")." ".escapeshellarg($filepath));
                
                if (strpos($data, "imagehash")) {
                    $retry++;
                    $data = false;
                    sleep(0.25);
                }
            }
            echo "CH: data{$retry}: ${data}\n";
            $array = explode("\n", trim($data));
            
            $sum = 0;
            foreach($array as $row) {
                $sum += (int)$row;
            }
            $average = $sum/64;
            
            foreach($array as $row) {
                if ((int)$row >= ((int)$average+(int)$tolerance)) {
                    $binary_string .= 1;
                } elseif ((int)$row <= ((int)$average-(int)$tolerance)) {
                    $binary_string .= 0;
                } else {
                    $binary_string .= 2;
                }
            }
            
            echo "CH: ${binary_string}\n";
            
            return $binary_string;
        }else{
            echo "CH: php: native\n";
            
            $tmp = getimagesize($filepath);
            $width = $tmp[0];
            $height = $tmp[1];
            $mimetype = $tmp["mime"];
            
            $thumb = imagecreatetruecolor($hamming_length, $hamming_length);
            
            if ($mimetype == "image/jpeg") {
                $source = imagecreatefromjpeg($filepath);
            } elseif ($mimetype == "image/png"){
                $source = imagecreatefrompng($filepath);
            } else {
                return false;
            }
            
            imagecopyresized($thumb, $source, 0, 0, 0, 0, $hamming_length, $hamming_length, $width, $height);
            
            imagefilter($thumb, IMG_FILTER_GRAYSCALE);
            
            
            $i = 0;
            $sum = 0;
            
            for ($x=0; $x<=($hamming_length-1); $x++) {
                for($y=0; $y<=($hamming_length-1); $y++) {
                    $i++;
                    $rgb = imagecolorat($thumb, $x, $y);
                    $r = ($rgb >> 16) & 0xFF;
                    $sum += $r;
                }
            }
            
            $average = $sum/$i;
            
            for($x=0; $x<=($hamming_length-1); $x++) {
                for($y=0; $y<=($hamming_length-1); $y++) {
                    $rgb = imagecolorat($thumb, $x, $y);
                    $r = ($rgb >> 16) & 0xFF;
                    
                    /*
                    if ((int)$r > (int)$average) {
                        $binary_string .= 1;
                    } else {
                        $binary_string .= 0;
                    }
                    */
                    
                    if ((int)$r >= ((int)$average+(int)$tolerance)) {
                        $binary_string .= 1;
                    } elseif ((int)$r <= ((int)$average-(int)$tolerance)) {
                        $binary_string .= 0;
                    } else {
                        $binary_string .= 2;
                    }
                    
                }
            }
            echo "CH: ${binary_string}\n";
            return $binary_string;
        }
    }
}

    
    
if (count($argv) < 12) {
    echo "\nUSAGE: php worker.php line workdir facemax thumbmax mode checksum exif created filename width height filesize perceptive_tolerance\n\n";
    var_dump($argv);
    die();
}

    //print_r($argv);
    
$Worker = new Worker($argv[1], $argv[2], $argv[3], $argv[4], $argv[5], $argv[6], $argv[7], $argv[8], $argv[9], $argv[10], $argv[11], $argv[12], $argv[13], $argv[14], $argv[15]);
